/****************************************************************************************

		BasicMovie.cpp

		Copyright: (c) 2001 Eovia Corp. All rights reserved.

		Author:	Emil (from RD code)
		Date:	1/21/99

		Revision History

		when		who			what & why
		==========	==========	======================================================
		
*****************************************************************************************/


#include "BasicMovie.h"
#include "MCCountedPtrHelper.h"
#include "IEx2DExportFilter.h"
#include "IShLayerList.h"
#include "COMImagesUtilities.h"
#include "IShRasterLayerUtilities.h"


/*****************************************************************************\
*                                                                             *
*  Basic implementation of IExMovie interface								  *
*                                                                             *
\*****************************************************************************/

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::QueryInterface(const MCIID& riid, void** ppvObj)
//------------------------------------------------------------------------
{
	if (MCIsEqualIID(riid, IID_IExMovie))
	{
		TMCCountedGetHelper<IExMovie> result(ppvObj);
		result = this;
		return MC_S_OK;
	}
	return TBasicDataExchanger::QueryInterface(riid, ppvObj);
}

//------------------------------------------------------------------------
uint32 TBasicMovie::AddRef()
//------------------------------------------------------------------------
{
	return TBasicDataExchanger::AddRef();
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::CreateMovieController(IMFPart** movieController)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::SelfStartPlaying(uint32 frameIndex)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::SelfStopPlaying(uint32 frameIndex)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::Initialize(const TMCString& fullPathName, const TSequencedMovieInfos* infos)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::BeginRead()
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::GetFrameRate(real32& frameRate)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::GetFrameCount(uint32& frameCount)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::GetFrame(IShRasterLayer** rasterLayer, uint32 frameIndex)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::GetFrame(IShLayerList** layerList, uint32 frameIndex, boolean forceLoad)
//------------------------------------------------------------------------
{
	TMCCountedPtr<IShRasterLayer> rasterLayer;
	if (GetFrame(&rasterLayer, frameIndex) == MC_S_OK)
	{
		gRasterLayerUtilities->CreateLayerList(layerList, 0, 0);

		(*layerList)->InsertLayer(rasterLayer);

		TMCRect bounds;
		rasterLayer->GetBounds(bounds);
		(*layerList)->SetBounds(bounds);

		return MC_S_OK;
	}
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::EndRead()
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

void TBasicMovie::GetCapabilities(ImageExportCapabilities& capabitilities)
{
	capabitilities.Clear();
}


//------------------------------------------------------------------------
boolean TBasicMovie::HasOptionsDialog()
//------------------------------------------------------------------------
{
	return false;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::ShowOptionsDialog(uint32 depth, real32& frameRate)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::BeginWrite(const TMCString& fullPathName, uint32 sizeH, uint32 sizeV, uint32 depth, real32 frameRate, boolean append)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::PutFrame(IShRasterLayer* rasterLayer,const TGBuffer32List* gBuffers, uint32 frameIndex)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::PutFrame(IShLayerList* layerList,const TGBuffer32List* gBuffers, uint32 frameIndex)
//------------------------------------------------------------------------
{
	TMCCountedPtr<IShRasterLayer> rasterLayer;
	layerList->GetFlattenedRasterLayer(&rasterLayer);

	if (rasterLayer)
		return PutFrame(rasterLayer, gBuffers, frameIndex);
	else
		return MC_S_FALSE;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::Flush()
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::GetMovieFullPathName(TMCString& fullPathName)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::EndWrite()
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::MakeCopy(const TMCString& fullPathName, TMCString& outFirstFileName)
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;
}

//------------------------------------------------------------------------
MCCOMErr TBasicMovie::DeleteMovie()
//------------------------------------------------------------------------
{
	return MC_E_NOTIMPL;	
}

void TBasicMovie::GetCompressionOptions(IExMovieCompressionOptions** movieOptions)
{
	TMCCountedGetHelper<IExMovieCompressionOptions> result(movieOptions);
}

void TBasicMovie::SetCompressionOptions(IExMovieCompressionOptions* movieOptions)
{
}
